#ifndef MAIN_H
#define MAIN_H

#include <stdlib.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/eeprom.h>
#include <avr/delay.h>   
#include <stdio.h>
#include <string.h>

#include "uart.h"
#include "buffer.h"
#include "global.h"
// #include "lcd.h"
#include "nmea_char.h"
#include "eeprom24xx.h"

// #define XTAL		11059000UL
#define XTAL		            3686400L

#define F_CPU		            3686400L

// alle Textstellen EEPROM im Quellcode durch __attribute__ ... ersetzen
#define EEPROM  __attribute__ ((section (".eeprom")))

// Status LEDs
#define LED_GREEN               PB2
#define PORT_LED_GREEN          PORTB
#define DDR_LED_GREEN           DDRB
#define LED_RED                 PB1
#define PORT_LED_RED            PORTB
#define DDR_LED_RED             DDRB

// Taster
#define SW_START                PD6
#define SW_STOP                 PD5
#define PORT_SW_START           PORTD
#define PORT_SW_STOP            PORTD
#define DDR_SW_START            DDRD
#define DDR_SW_STOP             DDRD
#define PIN_SW_START            PIND
#define PIN_SW_STOP             PIND

// MAX232
#define PORT_MAX232             PORTC
#define DDR_MAX232              DDRC
#define MAX232                  PC2       

#define LED_GREEN_ON            PORT_LED_GREEN |= (1 << LED_GREEN)
#define LED_GREEN_OFF           PORT_LED_GREEN &= ~(1 << LED_GREEN)
#define LED_GREEN_TOOGLE        PORT_LED_GREEN ^= (1 << LED_GREEN)

#define LED_RED_ON              PORT_LED_RED |= (1 << LED_RED)
#define LED_RED_OFF             PORT_LED_RED &= ~(1 << LED_RED)

#define MAX232_OFF              PORT_MAX232 |= (1 << MAX232)
#define MAX232_ON               PORT_MAX232 &= ~(1 << MAX232)

typedef struct {
    unsigned long date;                              // Datum        4 Bytes
    unsigned long time;                              // UTC-Uhrzeit  4 Bytes
    unsigned long latitude;                          // Breitengrad  4 Bytes (Komma entfernt)
    unsigned long longitude;                         // Lngengrad   4 Bytes (Komma entfernt)
    unsigned int altitude;                           // Hhe         2 Bytes (in m ohne Nachkomm
    char latitude_ns;                                 // N/S          1 Byte   
    char longitude_ew;                                // E/W          1 Byte
} tPositionSet;                                       //             20 Bytes

#endif

