/*
  Name:         GPS-Logger
  Copyright:    Keins
  Author:       Thomas Wiens
  Date: 19.09.06 00:14
  Description:  Kommandozeilenversion des GPS-Loggers
*/

#include <cstdlib>
#include <iostream>
#include <string>
#include <windows.h>
#include "mc_gpx.h"

void show_help(void);
int getopt(char *argument,char *option);
char retopt(char *argument);

using namespace std;

int main(int argc, char *argv[])
{     
    char dateiname[50];
    char trackname[50];
    char track_description[50];
    char waypoint_name[50];
    int com_port, i;

    // Kommandozeilenparameter auswerten
	if(argc < 10 || getopt(argv[1],"h") == TRUE) {
		show_help();
		return 0;
	}   
    int count = 0;  
    for (i = 1; i < argc; i += 2) {
        switch (retopt(argv[i])) {
            case 'c':
                com_port= atoi(argv[i+1]);
                count++;
                break;
            case 'd':
                strncpy(dateiname, argv[i+1], 49);
                count++;
                break;
            case 't':
                strncpy(trackname, argv[i+1], 49);
                count++;
                break;
            case 'e':
                strncpy(track_description, argv[i+1], 49);
                count++;
                break;
            case 'w':
                strncpy(waypoint_name, argv[i+1], 49);
                count++;
                break;
            default:
                show_help();
                return 1;
        }
    }
    if (count != 5) {
        show_help();
        return 1;
    }
    if (get_data_from_logger(1, dateiname, trackname, track_description, waypoint_name)){
        return 1;
    }
    cout << "Route erfolgreich geschrieben!" << endl;            
    return EXIT_SUCCESS;
}

void show_help(void) {
	cout << "\nProgrammaufruf: GPS_Logger.exe [OPTION]\n"\
		"\t -c n               \tn = Nummer der COM-Schnittstelle\n"\
		"\t -d \"dateiname\"   \tName der zu erstellenden GPX-Datei\n"\
		"\t -t \"trackname\"   \tName des Tracks\n"\
		"\t -e \"description\" \tBeschreibung der Route\n"\
		"\t -w \"wapointnames\"\tBezeichnung der Wegpunkte\n"\
		"\t -h \t\t\tDieser Hilfe\n\n"\
        "Beispiel:\n GPS_Logger.exe -c 1 -d \"Motorrad_Route_1.gpx\" -t \"Motorrad 2.9.2006\" "\
        "-e \"Rundfahrt 1\" -w \"Marke\"\n\n";
}

int getopt(char *argument,char *option) {
	if( argument[0]=='-' && argument[1]==option[0])
		return TRUE;
	return FALSE;
}

char retopt(char *argument) {
	if( argument[0]=='-' && argument[1] != '\0')
		return argument[1];
	return FALSE;
}
