// Headerdatei fr mc_gpx.cpp
#ifndef _MC_GPX
#define _MC_GPX

#include <cstdlib>
#include <iostream>
#include <fstream>
#include <string>
#include <windows.h>
#include "Serial.h"

#define TRKPT_DATASET_LENGTH  50
#define WAYPT_DATASET_LENGTH  9

// Fehlercodes
#define GPX_ERR_SERIAL_OPEN   1       // Fehler beim ffnen der seriellen Schnittstelle
#define GPS_ERR_FILE_OPEN     2       // Fehler beim ffnen der Datei
#define GPS_ERR_CONTR_COM     3       // Fehlerhafte oder keine Antwort vom Gert

#define DEBUG

typedef struct {
    char date[11];                              // Datum        4 Bytes
    char time[11];                              // UTC-Uhrzeit  4 Bytes
    char latitude[13];                          // Breitengrad  4 Bytes (Komma entfernt)
    char longitude[13];                         // Lngengrad   4 Bytes (Komma entfernt)
    char altitude[5];                           // Hhe         2 Bytes
    char latitude_ns[2];                        // N/S          1 Byte   
    char longitude_ew[2];                       // E/W          1 Byte
} tPositionSet;   

typedef struct {
    char datetime[22];
    char latitude[15];
    char longitude[15];
    char altitude[5];
} tGPXtrackPoint;

int extract_data(char *extr_string, char begin[20], char end[20]);
int get_gps_trkPoint(int trkpt_number, char *line);
void get_gpx_data(char *line, tGPXtrackPoint *gpx);
void add_gpx_trkPoint_to_file(tGPXtrackPoint *gpx);
void add_gpx_wayPoint_to_file(tGPXtrackPoint *gpx, char *pointname);
int get_waypoint(int point_number);
int get_data_from_logger(int com_port, char filename[50], char trackname[50], char track_description[50], char waypoint_names[50]);
                         
#endif
